﻿package com.afcomponents.common.display{
	import flash.geom.*;
	import flash.errors.*;
	import flash.display.*;
	import com.afcomponents.common.graphics.*;
	public class BitmapReflection extends Reflection{

		/**
		*
		* @static public (constant)
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword MAX_BMP_SIZE
		*/
		static public const MAX_SIZE:int = 2880;
		
		/**
		*
		* @protected
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword _bounds
		*/
		protected var _bounds:Rectangle = null;
		
		/**
		*
		* @protected
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword _useTargetSize
		*/
		protected var _useTargetSize:Boolean = false;
		
		/**
		*
		* @protected
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword _useTargetSize
		*/
		protected var _smoothing:Boolean = false;
		
		/**
		*
		* @protected
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword _bitmapData
		*/
		protected var _bitmapData:BitmapData = null;

		/**
		*
		* @protected
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword _lastBounds
		*/
		protected var _lastBounds:Rectangle = null;

		/**
		*
		* @public
		* @param t
		* @param s
		* @param useReflector
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword BitmapReflection
		*/
		public function BitmapReflection(t:DisplayObject, s:ReflectionStyle=null, useReflector:Boolean=true):void{
			super(t, s, useReflector);
		}

		/**
		*
		* @public (getter)
		* @return Rectangle
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword bounds
		*/
		public function get bounds():Rectangle{
			return this._bounds ? this._bounds : this._lastBounds;
		}

		/**
		*
		* @public (setter)
		* @param r
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword bounds
		*/
		public function set bounds(r:Rectangle):void{
			r.width = r.width>0 ? r.width : 1;
			r.height = r.height>0 ? r.height : 1;
			this._bounds = r;
		}

		/**
		*
		* @public (getter)
		* @return Boolean
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword smoothing
		*/
		public function get smoothing():Boolean{
			return this._smoothing;
		}

		/**
		*
		* @public (setter)
		* @param p
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword smoothing
		*/
		public function set smoothing(p:Boolean):void{
			this._smoothing = p;
		}

		/**
		*
		* @public (getter)
		* @return Boolean
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword useTargetSize
		*/
		public function get useTargetSize():Boolean{
			return this._useTargetSize;
		}

		/**
		*
		* @public (setter)
		* @param p
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword useTargetSize
		*/
		public function set useTargetSize(p:Boolean):void{
			this._useTargetSize = p;
		}

		/**
		*
		* @public (getter)
		* @return BitmapData
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword bitmapData
		*/
		public function get bitmapData():BitmapData{
			return this._bitmapData;
		}
		
		/**
		*
		* @public
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword remove
		*/
		override public function remove():void{
			this._bitmapData.dispose();
			this._bitmapData = null;
			super.remove();
		}

		/**
		*
		* @override protected
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword redraw
		*/
		override protected function redraw():void{
			if(this._bitmapData) this._bitmapData.dispose();
			var tbounds:Rectangle = this._target.getBounds(this._target);
			tbounds.width = tbounds.width<MAX_SIZE ? tbounds.width : MAX_SIZE;
			tbounds.height = tbounds.height<MAX_SIZE ? tbounds.height : MAX_SIZE;
			tbounds.width = tbounds.width>0 ? tbounds.width : 1;
			tbounds.height = tbounds.height>0 ? tbounds.height : 1;
			if(this._bounds) this._lastBounds = this._bounds;
			else this._lastBounds = tbounds;
			this.redrawBitmap(tbounds);
		}

		/**
		*
		* @override protected
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword redrawDisabled
		*/
		override protected function redrawDisabled():void{
			if(this._bitmapData) this._bitmapData.dispose();
			this._bitmapData = new BitmapData(1, 1, true, Reflection.TRANSPARENT_COLOR);
			drawReflectionBitmap(this._bitmapData, this._reflection);
		}

		/**
		*
		* @protected
		* @param tb
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword redrawBitmap
		*/
		protected function redrawBitmap(tb:Rectangle):void{
			if(this._useTargetSize){
				this._bitmapData = new BitmapData(tb.width, tb.height, true, Reflection.TRANSPARENT_COLOR);
				this._bitmapData.draw(this._target, null, null, null, this._lastBounds, this._smoothing);
			}else{
				this._bitmapData = new BitmapData(this._lastBounds.width, this._lastBounds.height, true, Reflection.TRANSPARENT_COLOR);
				this._bitmapData.draw(this._target, new Matrix(1, 0, 0, 1, -this._lastBounds.x, -this._lastBounds.y), null, null, null, this._smoothing);
			}
			drawReflectionBitmap(this._bitmapData, this._reflection);
			super.redraw();
			drawReflectionLayer(this._reflection.getBounds(this), this._style, this._layer);
		}

		/**
		*
		* @static public
		* @param bmp
		* @param shape
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword drawReflectionBitmap
		*/
		static public function drawReflectionBitmap(bmp:BitmapData, shape:Shape):void{
			var g:Graphics = shape.graphics;
			g.beginBitmapFill(bmp, new Matrix(1, 0, 0, -1));
			g.drawRect(0, 0, bmp.width, bmp.height);
			g.endFill();
		}
	}
}