﻿package com.afcomponents.common.display{
	import flash.geom.*;
	import flash.utils.*;
	import flash.errors.*;
	import flash.display.*;
	import com.afcomponents.common.graphics.*;
	import com.afcomponents.common.display.reflection.*;
	public class Reflection extends Sprite{

		/**
		*
		* @static public (constant)
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword TRANSPARENT_COLOR
		*/
		static public const TRANSPARENT_COLOR:int = 0x000001;

		/**
		*
		* @protected
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword _target
		*/
		protected var _target:DisplayObject = null;

		/**
		*
		* @protected
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword _reflection
		*/
		protected var _reflection:Shape = new Shape();

		/**
		*
		* @protected
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword _layer
		*/
		protected var _layer:Shape = new Shape();

		/**
		*
		* @protected
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword _style
		*/
		protected var _style:ReflectionStyle = null;

		/**
		*
		* @protected
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword _reflector
		*/
		protected var _reflector:Reflector = null;

		/**
		*
		* @public
		* @param t
		* @param s
		* @param useReflector
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword Reflection
		*/
		public function Reflection(t:DisplayObject, s:ReflectionStyle=null, useReflector:Boolean=true):void{
			super();
			_target = t;
			if(!t) throw new Error('['+getQualifiedClassName(this)+'] class without target!');
			_style = s ? s : new ReflectionStyle();
			preset();
			if(useReflector) _reflector = new Reflector(this);
		}

		/**
		*
		* @protected
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword preset
		*/
		protected function preset():void{
			this._layer.blendMode = BlendMode.ALPHA;
			super.cacheAsBitmap = true;
			this.addChild(this._reflection);
			this.addChild(this._layer);
		}

		/**
		*
		* @public (getter)
		* @return DisplayObject
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword target
		*/
		public function get target():DisplayObject{
			return this._target;
		}

		/**
		*
		* @public (getter)
		* @return Shape
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword reflection
		*/
		public function get reflection():Shape{
			return this._reflection;
		}

		/**
		*
		* @public (getter)
		* @return Shape
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword layer
		*/
		public function get layer():Shape{
			return this._layer;
		}

		/**
		*
		* @public (getter)
		* @return ReflectionStyle
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword style
		*/
		public function get style():ReflectionStyle{
			return this._style;
		}

		/**
		*
		* @public (getter)
		* @return Reflector
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword reflector
		*/
		public function get reflector():Reflector{
			return this._reflector;
		}

		/**
		*
		* @override public (setter)
		* @param b
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword cacheAsBitmap
		*/
		override public function set cacheAsBitmap(b:Boolean):void{
			throw new IllegalOperationError('"cacheAsBitmap" not implemented in ['+getQualifiedClassName(this)+'] class, extended from [com.afcomponents.common.display::Reflection].');
		}

		/**
		*
		* @public
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword refresh
		*/
		public function refresh():void{
			this._reflection.graphics.clear();
			this._layer.graphics.clear();
			if(this._style.enabled){
				this.redraw();
				this._reflection.alpha = this._style.clipAlpha;
				if(this._style.usePosition) this.refreshPosition();
			}else this.redrawDisabled();
		}

		/**
		*
		* @public
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword remove
		*/
		public function remove():void{
			this._target = null;
			this._reflection = null;
			this._layer = null;
			this._style = null;
			if(this._reflector) this._reflector.remove();
			this._reflector = null;
			if(this.parent) this.parent.removeChild(this);
		}

		/**
		*
		* @public
		* @param r
		* @param s
		* @param shape
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword drawReflectionLayer
		*/
		public function drawReflectionLayer(r:Rectangle, s:ReflectionStyle, shape:Shape):void{
			var g:Graphics = shape.graphics;
			g.beginGradientFill(GradientType.LINEAR, [Reflection.TRANSPARENT_COLOR, Reflection.TRANSPARENT_COLOR], [s.alpha, 0], [0, s.matrixRatio*255], getReflectionMaskMatrix(r, s));
			g.drawRect(0, 0, r.width, r.height);
			g.endFill();
		}

		/**
		*
		* @public
		* @param r
		* @param s
		* @return Matrix
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword getReflectionMaskMatrix
		*/
		public function getReflectionMaskMatrix(r:Rectangle, s:ReflectionStyle):Matrix{
			var matrix:Matrix = new Matrix();
			matrix.createGradientBox(r.width, s.matrixDropOff>0 ? r.height/s.matrixDropOff : Number.MIN_VALUE, Math.PI*0.5, 0, 0);
			return matrix;
		}

		/**
		*
		* @protected
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword redraw
		*/
		protected function redraw():void{
			if(this._style.useTransform) this.refreshTransform();
		}

		/**
		*
		* @protected
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword redrawDisabled
		*/
		protected function redrawDisabled():void{
			// override 
		}

		/**
		*
		* @internal
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword refreshTransform
		*/
		internal function refreshTransform():void{
			this._layer.x = this._layer.y = 0;
			var m:Matrix = this._target.transform.matrix;
			this._reflection.transform.matrix = new Matrix(m.a, -m.b, -m.c, m.d);
			var b:Rectangle = this._reflection.getBounds(this);
			this._reflection.x -= b.x;
			this._reflection.y -= b.y;
		}

		/**
		*
		* @internal
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword refreshPosition
		*/
		internal function refreshPosition():void{
			var b:Rectangle = this._target.parent ? this._target.getBounds(this._target.parent) : this._target.getBounds(this._target);
			this.x = b.x;
			this.y = b.y+b.height+this._style.distance;
		}
	}
}