﻿package com.afcomponents.common.display.reflection{
	import flash.utils.*;
	import flash.events.*;
	import com.afcomponents.common.display.*;
	public class Reflector extends Object{

		/**
		*
		* @protected
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword _reflection
		*/
		protected var _reflection:Reflection = null;

		/**
		*
		* @protected
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword _timer
		*/
		protected var _timer:Timer = null;

		/**
		*
		* @protected
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword _refreshReflection
		*/
		protected var _refreshReflection:Boolean = true;

		/**
		*
		* @public
		* @param r
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword Reflector
		*/
		public function Reflector(r:Reflection):void{
			super();
			_timer = new Timer(1000/r.style.refreshRate);
			_timer.addEventListener(TimerEvent.TIMER, onTimer);
			r.addEventListener(Event.ENTER_FRAME, this.onEnterFrame);
			_reflection = r;
			this.start();
		}

		/**
		*
		* @public
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword start
		*/
		public function start():void{
			this._timer.start();
		}

		/**
		*
		* @public
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword stop
		*/
		public function stop():void{
			this._timer.reset();
		}

		/**
		*
		* @public
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword remove
		*/
		public function remove():void{
			this._timer.reset();
			this._timer.removeEventListener(TimerEvent.TIMER, this.onTimer);
			this._reflection.removeEventListener(Event.ENTER_FRAME, this.onEnterFrame);
			this._timer = null;
			this._reflection = null;
			
		}

		/**
		*
		* @public (getter)
		* @return Boolean
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword isStarted
		*/
		public function get isStarted():Boolean{
			return this._timer.running;
		}

		/**
		*
		* @protected
		* @param e
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword onTimer
		*/
		protected function onTimer(e:TimerEvent):void{
			this._refreshReflection = true;
		}

		/**
		*
		* @protected
		* @param e
		* @return void
		* @playerversion Flash 9.0.28.0
		* @langversion 3.0
		* @keyword onEnterFrame
		*/
		protected function onEnterFrame(e:Event):void{
			this._timer.delay = 1000/this._reflection.style.refreshRate;
			this._reflection.refresh();
			this._refreshReflection = false;
		}
	}
}